# Xray Format Import

## Introduction

This document describes how to export Xray issues from a Jira instance to import them into Squash TM.

The followed Xray issues are supported : 
- Test
- Precondition
- Test plan
- (Sub-) Test Execution

The supported file type for import is the XML format. It is possible to import one or multiple files to generate a zip file named `pivot.zip` containing the JSON files.

## Table of content
- [Issue export](#issue-export)
  - [Basic export](#basic-export)
  - [Specifics](#specifics)
    - [Export to separate files](#export-to-separate-files)
    - [Configure the limit of issues](#configure-the-limit-of-issues)
- [Import Xray issues into Squash TM](#import-xray-issues-into-squash-tm)
  - [File selection and import name](#file-selection-and-import-name)
  - [Import configuration](#import-configuration)
  - [Pivot generation](#pivot-generation)
  - [Import request](#import-request)
- [Xray XML processing](#xray-xml-processing)
  - [Temporary tables structure](#temporary-tables-structure)
    - [ITEM_XRAY_TABLE](#item_xray_table)
    - [CUSTOM_FIELD_XRAY_TABLE](#custom_field_xray_table)
  - [Priority and status](#priority-and-status)
    - [Priority](#priority)
    - [Status](#status)
  - [Processing order](#processing-order)
  - [Test case folder](#test-case-folder)
  - [Test case](#test-case)
    - [Manual Test](#manual-test)
    - [Generic Test](#generic-test)
    - [Cucumber Test case](#cucumber-test-case)
  - [Called Test Case](#called-test-case)
  - [Campaign](#campaign)
  - [Iteration](#iteration)


## Issue export
### Basic export
The export is done through the Jira instance interface using ticket search.
To access ticket search, go to the `Jira homepage` and then to the menu `Issues > Search`.
In the search bar, you can filter the issues to export using a JQL query.
The main filters to use are:
- `project = "PROJECT_NAME"`: to retrieve the project issues
- `issuetype in ("ISSUE_NAME_1", "ISSUE_NAME_2", etc.)`: to retrieve only Test type issues  
> Example: `project = "MyProject" AND issuetype in ("Test", "Precondition", "Test Plan", "Test Execution")`

Once the issues are filtered, you can export them by clicking on the `Export button > XML`.

The XML export does not download automatically. A new page is loaded with the content of the issues to export in XML format.  
The generation is complete when the page contains indented XML tags with the header:
```html
This XML file does not appear to have any style information associated with it. The document tree is shown below.
   
    <!-- 
    RSS generated by JIRA (9.2.0#920000-sha1:ef10a0be9967f4b128858ffd75f499140d8d6401) at Tue Jul 09 16:39:51 CEST 2024
    
    It is possible to restrict the fields that are returned in this document by specifying the 'field' parameter in your request.
    For example, to request only the issue key and summary append 'field=key&field=summary' to the URL of your request.
     -->
    <!--  If you wish to do custom client-side styling of RSS, uncomment this:
    <?xml-stylesheet href="https://{{your_instance}}/styles/jiraxml2html.xsl" type="text/xsl"?>
     -->
```
Once the header is displayed, you can download the page content with a `right-click > Save as` or with the shortcut `Ctrl + S`.

### Specifics
You can only export a limited number of issues at a time, with a default limit of 1000 issues set in the Jira administration area.
If this limit is reached, there are two solutions:
- Export issues to separate files
- Configure the limit in the Jira administration area

#### Export to separate files
To export into separate files, add `&pager/start=xxxx` to the end of the XML export URL after saving the content of the page, with `xxxx` being the starting issue number.
> Example :
> - issue from 1 to 1000: `&pager/start=0`
> - issue from 1000 to 2000: `&pager/start=1000`
> - .etc

#### Configure the limit of issues
To change the default maximum number of issues exported from search results :
- In the upper-right corner of the screen, select `Administration  > System`.
- Select `Advanced Settings`
- Set the value of the `jira.search.views.default.max` and `jira.search.views.max.limit` properties to the desired number of issues to be retrieved by the Lookup action.


## Import Xray issues into Squash TM
To import the XML file(s) into Squash TM, access the `Import view` within the `Project view`.

Two options are available for importing the issues:
- Import from Xray
- Import from pivot format

The `Import from Xray` option converts the XML file(s) into a zip file containing the JSON files of the imported tickets.
This import is completed in several steps within the same modal.

### File selection and import name
This step allows you to select the XML file(s) to import and define the name of the import. Both fields are mandatory.

#### import name field  
This field can contain any text up to a maximum of 255 characters.

#### File selection  
It is possible to import multiple files at once by selecting them all in the file selection window or by adding them one by one.
Once the files are confirmed, the names of the selected files are displayed in the modal with red crosses to remove them if necessary.
Two checks are performed on the selected files:
- The file type must be `XML`.
- If a file matches one that has already been selected, it will not be added to the list. This check is based on the file name, file type, and file size.

### Import configuration
This step checks if the selected files are valid XML files.
If the files are not valid, an error message is displayed with the names of the invalid file(s) and the reason for the error.

After validation, the import configuration is displayed with the following grid:
- `Xray entities`: issues found in the XML file(s)
- `Number of issues`: number of issues for each entity


### Pivot generation
This step generates two files in the temporary folder:
- A pivot zip file containing the JSON files of the imported tickets. The name of the file is `pivot + hashCode of the Spring transaction + .zip`.
- A log file containing the import information. The name of the file is `pivot_log + hashCode of the Spring transaction + .txt`.

A table is displayed with the following information:
- `Squash Entity`
- `Successful, Warning, Failed entities`: number of issues for each status

The log file can be downloaded by clicking on the `Download the report (txt)` link.

These two files are deleted when the modal is closed.

### Import request
This step sends the import request to the server. The import is executed as a scheduled task, and the modal can be closed once the request is sent.

## Xray XML processing
To read the XML file, an XML parser is used: the `StAX` library streams the file and extracts the information.

The XML file structure is a succession of `item` elements containing the information of an issue.
Example :
```xml
<item>
    <title>X</title>
    <link>X</link>
    <project id="XX" key="XX">X</project>
    <description>X</description>
    <environment>X</environment>
    <key id="XX">X</key>
    <summary>X</summary>
    <type id="XX" iconUrl="XX">X</type>
    <priority id="XX" iconUrl="XX">X</priority>
    <status id="XX" iconUrl="XX" description="XX">X</status>
    <statusCategory id="XX" key="XX" colorName="XX" />
    <resolution id="XX">X</resolution>
    <assignee username="XX">X</assignee>
    <reporter username="XX">X</reporter>
    <labels>
        <label>X</label>
    </labels>
    <created>X</created>
    <updated>X</updated>
    <due>X</due>
    <votes>X</votes>
    <watches>X</watches>
    <issuelinks>
        <issuelinktype id="XX">
            <name>X</name>
            <outwardlinks description="XX">
                <issuelink>
                    <issuekey id="XX">X</issuekey>
                </issuelink>
            </outwardlinks>
            <inwardlinks description="XX">
                <issuelink>
                    <issuekey id="XX">X</issuekey>
                </issuelink>
            </inwardlinks>
        </issuelinktype>
    </issuelinks>
    <attachments>
        <attachment id="XX" name="XX" size="XX" author="XX" created="XX" />
    </attachments>
    <subtasks>
        <subtask id="XX">X</subtask>
    </subtasks>
    <customfields>
        <customfield id="XX" key="XX">
            <customfieldname>X</customfieldname>
            <customfieldvalues>
                <customfieldvalue key="XX">X</customfieldvalue>
            </customfieldvalues>
        </customfield>
    </customfields>
</item>
```
Each `item` element is processed to extract information into two DTO objects (`ItemXrayDto` and `CustomFieldXrayDto`) and then inserted into two temporary tables:
- `ITEM_XRAY_TABLE + hashCode of the Spring transaction`: contains the issue information
- `CUSTOM_FIELD_XRAY_TABLE + hashCode of the Spring transaction`: contains the custom fields of the issue

This insertion is done in batches of 10 issues.

### Temporary tables structure
Each Spring transaction generates two unique temporary tables to store the information of the issues and their custom fields. 
After the import is completed, the tables are dropped.

#### ITEM_XRAY_TABLE

| Column name     | Type   | XML element   | Description                                                                       |
|-----------------|--------|---------------|-----------------------------------------------------------------------------------|
| id              | BIGINT | /             | Primary key                                                                       |
| project         | CLOB   | `project`     | name of the project                                                               |
| title           | CLOB   | `title`       | [KEY] + The title of the issue                                                    |
| link            | CLOB   | `link`        | url of the issue                                                                  |
| description     | CLOB   | `description` | description field of the issue                                                    |
| key             | CLOB   | `key`         | jira key -> [project key + Integer]                                               |
| summary         | CLOB   | `summary`     | title of the issue                                                                |
| type            | CLOB   | `type`        | type name of the issue                                                            |
| priority        | CLOB   | `priority`    | priority of the issue                                                             |
| status          | CLOB   | `status`      | status of the issue                                                               |
| created         | CLOB   | `created`     | creation date of the issue (format : EEE, dd MMM yyyy HH:mm:ss Z + Locale.ENGLISH |
| reporter        | CLOB   | `reporter`    | username                                                                          |
| label           | CLOB   | `label`       | jira lbel                                                                         |
| pivot_id        | CLOB   | /             | Pivot id generated of this issue                                                  |
| parent_pivot_id | CLOB   | /             | Pivot id generated of the entity parent                                           |


#### CUSTOM_FIELD_XRAY_TABLE
| Column name                 | Type    | XML element                                  | Description                                          |
|-----------------------------|---------|----------------------------------------------|------------------------------------------------------|
| id                          | BIGINT  | /                                            | Primary key                                          |
| item_id                     | BIGINT  | /                                            | Foreign key to the ITEM_XRAY_TABLE                   |
| key                         | CLOB    | `customfield`                                | key of the custom field                              |
| name                        | CLOB    | `customfieldname`                            | name of the custom field                             |
| value                       | CLOB    | `customfieldvalue`                           | value of the custom field                            |
| step_index                  | INTEGER | `index` inside `step`                        | index of the step                                    |
| step_action                 | CLOB    | `Action` inside `step`                       | action of the step                                   |
| step_data                   | CLOB    | `Data` inside `step`                         | data of the step                                     |
| step_expected_result        | CLOB    | `Expected_Result` inside `step`              | expected result of the step                          |
| step_called_test_key        | CLOB    | `key` attribute of `call-test` inside `step` | key of the called test                               |
| step_called_test_parameters | CLOB    | `parameter` inside `call-test`               | parameters of the called test (format : {key=value}) |
| dataset_row                 | INTEGER | `row` inside `dataset`                       | row of the dataset                                   |
| dataset_name                | CLOB    | `name` inside `parameter` inside `dataset`   | name of the parameter                                |
| dataset_value               | CLOB    | `value` inside `parameter` inside `dataset`  | value of the parameter                               |
| cuf_pivot_id                | CLOB    | /                                            | Pivot id used in Called test case                    |
| issue_link_name             | CLOB    | `name` inside `issuelinktype`                | name of the issue link                               |
| issue_link_key              | CLOB    | `issuekey`                                   | key of the issue link                                |
| issue_link_relationship     | CLOB    | `outwardlinks` or `inwardlinks`              | relationship of the issue link                       |

### Priority and status
The priority and the status of the issue have a default mapping

#### Priority
| Xray       | Requirement | Test Case |
|------------|-------------|-----------|
| Lowest     | Minor       | Low       |
| Low        | Minor       | Low       |
| Medium     | Major       | Medium    |
| High       | Major       | High      |
| Highest    | Critical    | Very High |
| NO_MATCHED | Undefined   | Low       |

#### Status
| Xray        | Requirement      | Test Case        | Campaign    | Iteration   |
|-------------|------------------|------------------|-------------|-------------|
| Reopened    | Work in progress | Work in progress | Planned     | Planned     |
| Open        | Work in progress | Work in progress | Planned     | Planned     |
| In Progress | Work in progress | Work in progress | In Progress | In Progress |
| Resolved    | Under review     | Under review     | Finished    | Finished    |
| Closed      | Approved         | Approved         | Archived    | Archived    |
| NO_MATCHED  | Work in progress | Work in progress | Undefined   | Undefined   |

### Processing order
The processing of Xray entities is done in the following order:
1. Test folder
2. Test (Manual, Generic, Cucumber)
3. Called Test
4. Campaign
5. Iteration

### Test case folder
Test cases are the only issues that have a folder.
To create the folder tree, an SQL query is executed on the `CUSTOM_FIELD_XRAY_TABLE` where the custom field `TestRepository` with the key `com.xpandit.plugins.xray:test-repository-path-custom-field` is not empty.
The values of the custom field are split by the `/` character to create the folder tree.
> Example: Folder1/Folder2/Folder3 

The pivot ID of each folder is stored in a map to maintain the parent-child relationship.

### Test case
Two issues are associated with a test case:
- Test: a test case
- Precondition: prerequisite for the test case


#### Test Type
Test issues have a specific type. 
This type is extracted from the custom field `Test Type` with the key `com.xpandit.plugins.xray:test-type-custom-field`.

Test issues can be of three types:
- Manual: Classic test case
- Generic: Classic test case without steps
- Cucumber: Gherkin test case
> if the type is not found, the test is skipped and an error is displayed in the log file.

#### Manual Test
1- **Basic part**

The mapping of the basic part of the test case is done with:
- name: `summary`
- reference: `key`
- importance: `priority`
- status: `status`
- nature and type: **null**
- testCaseKind: **TestCaseKind.STANDARD**
- parentType: custom field `TestRepository`
- pivotId: generated when the test is inserted into the database
- description: combination of `description`, `link`, `status`, and `priority`
> If `importance` or `status` does not match the default mapping, a warning is displayed in the log file.

2- **Prerequisite**

The test can be associated with precondition issues.
This association is made using the custom field `Pre-Conditions association with a Test` with the key `com.xpandit.plugins.xray:test-precondition-custom-field`.
For each precondition, the `key` and the custom field `Conditions` with the key `com.xpandit.plugins.xray:precondition-editor-custom-field` are extracted.
This information is stored in the test case prerequisite.
> Example prerequisite:
> ```text
> # [XRAY-KEY]
> My precondition value here
> ```  

> If the precondition is not found, a warning is displayed in the log file.

3- **Steps**

The steps of the test case are extracted from the custom field `Manual Test Steps` with the key `com.xpandit.plugins.xray:manual-test-steps-custom-field`.
The custom field has the following format:
```xml
<customfieldvalues>
    <steps>
        <step>
            <index>1</index>
            <Action><![CDATA[action step with param: {test-param}param1{test-param}]]></Action>
            <Data><![CDATA[data step]]></Data>
            <Expected_Result><![CDATA[expected result step]]></Expected_Result>
        </step>
        <step>
            <index>2</index>
            <call-test key="XX">
            </call-test>
        </step>
    </steps>
</customfieldvalues>
```
These steps are sorted by the `step_index`.
The mapping of the steps is done with:
- action: `step_action` and `step_data`
- expected result: `step_expected_result`

The parameters inside steps are converted to the Squash TM format `${param1}`.
> Parameter names are formatted to match the Squash TM regex `[A-Za-z0-9_-]{1,255}`

4- **Dataset**

The test case can include a dataset.
This dataset is extracted from the custom field `Dataset values` with the key `com.xpandit.plugins.xray:test-dataset-custom-field`.
The custom field has the following format:
```xml
<customfieldvalues>
    <dataset>
        <combinatorial/>
        <seeding>
            <row>
                <parameter>
                    <name>param1</name>
                    <value>value1</value>
                </parameter>
            </row>
        </seeding>
    </dataset>
</customfieldvalues>
```

In the `CUSTOM_FIELD_XRAY_TABLE`, the dataset is stored with the `dataset_row`, `dataset_name`, and `dataset_value` columns.
Each row of the `CUSTOM_FIELD_XRAY_TABLE` corresponds to one row and one parameter of the dataset.
Each unique parameter name is associated with a pivot_id and stored in a list to create the JSON array of the dataset parameters.
> Parameter names are formatted to match the Squash TM regex `[A-Za-z0-9_-]{1,255}`.

After associating the dataset parameters with a pivot_id, the dataset is grouped by the `dataset_row`, and the dataset JSON array is filled with:
- id: pivot_id generated
- name: `Dataset_ + integer`
- parameters: list of the dataset parameters
    - param_id: pivot_id generated for the dataset parameter
    - value: associated value

> The test case can be called in a step with a dataset that doesn't exist in this test case.
> A corrective action is taken to create this dataset with the name `Dataset_Called_ + integer` (and the dataset parameter if needed).

#### Generic Test
A generic test case is a test case without steps.
The mapping is the same as for a manual test case except for the step part.
The action step is filled with the value of the custom field `Generic Test Definition` with the key `com.xpandit.plugins.xray:path-editor-custom-field`.


#### Cucumber Test case
1- **Basic part**

The mapping of the basic part of the test case is done with:
- name: `summary`
- reference: `key`
- importance: `priority`
- status: `status`
- nature and type: **null**
- testCaseKind: **TestCaseKind.GHERKIN**
- parentType: custom field `TestRepository`
- pivotId: generated when the test is inserted into the database
- description: combination of `description`, `link`, `status`, and `priority`


2- **Gherkin script**

The Gherkin script is extracted from the custom field `Cucumber Scenario` with the key `com.xpandit.plugins.xray:steps-editor-custom-field`.
The line breaks are the HTML tag `<br/>`, and it can be in three formats:
- Complete script with the `Feature` keyword
- Incomplete script:
    - with only `Scenario`, `Scenario Outline`, or `Background` without the `Feature` keyword
    - with only step keywords

After formatting the script, an analysis is performed to:
- Identify the language used in the script by matching Gherkin tokens (Feature, Background, Scenario, Scenario Outline, Examples)
- Determine the script's state:
    - If it contains the `Feature` keyword: no change.
    - If it contains the `Background`, `Scenario`, or `Scenario Outline` keywords, the `Feature` keyword is added, with the test case title as the feature name.
    - If it contains none of the above keywords, the `Feature` and `Scenario` (or `Scenario Outline` if the `Examples` keyword is present) keywords are added.

After the analysis, the script is parsed into a Gherkin document.
> If the parser throws an exception, the test is skipped, and an error line is logged.

3- **Precondition**

Like the manual test case, the test can be associated with precondition issues using the same custom fields.
> If a Cucumber test is associated with a precondition, then this precondition is always of the Cucumber type.

If the precondition is found, there are two possibilities:
- If no background exists, a background is added.
- If a background exists, steps are appended after the last step.

The steps added to the background include a comment starting with `# @ + Xray key` followed by the retrieved values. No further analysis is performed on these steps.

4- **Dataset**

Each step and its arguments are analyzed to determine which dataset value is associated with which scenario:
- If the scenario doesn't have the `Examples` keyword, an `Example` is added.
    - If needed, the `Scenario` keyword becomes `Scenario Outline`.
- If the scenario already has the `Examples` keyword, the table inside is analyzed:
    - If the header matches all parameter names, a new row with the dataset values is added to the table.
    - If the header does not match all parameter names, another "Examples" section is added.

If any dataset values are not used, the following is added to the end of the script:
```text
# Dataset not used in the script
# | header |
# | value  |
```

5- **Examples**

The Cucumber test contains : 
- 1 Precondition
- 1 dataset ({param4=value4})
- 1 Gherkin script

Xray Precondition :
```text
    Given background step
```

Xray Script :
```text
    Given a step with param: {param1}
    When a step with param: {param2}
    Then a step with param: {param3}

    Examples:
      | param1 | param2 | param3 |
      | value1 | value2 | value3 |

```

In Squash TM, the test case is created with the following script:
```text
    Feature: Test case title

    Background:
        Given background step

    Scenario Outline: Test case title
        Given a step with param: {param1}
        When a step with param: {param2}
        Then a step with param: {param3}

    Examples:
      | param1 | param2 | param3 |
      | value1 | value2 | value3 |
      
    # Dataset not used in the script
    # | param4  |
    # | value4  |
```

### Called Test Case
The called test case is a test case invoked within a step of another test case.
To select all the called test cases, an SQL query is executed on the `ITEM_XRAY_TABLE` and `CUSTOM_FIELD_XRAY_TABLE` where the `step_called_test_key` is not null.
The called test case is created with this structure:
- id: Pivot id generated
- caller_id: Pivot id of the test case within the item DTO
- called_id: Pivot id of the test where the value of `step_called_test_key` matches the item's `key`
- parameter_assignation_mode:
    - `NOTHING` if the custom field `step_called_test_parameters` is null
    - `CALLED_DATASET` if the custom fields `step_called_test_parameters` and `cuf_pivot_id` are not null

> If the called_id is not found, an error is logged.  
> If `step_called_test_parameters` is not null and `cuf_pivot_id` is null, a warning is logged.

### Campaign
There are two conditions to create a campaign:
- If the issue type is `Test Plan`
- If the issue type is `Test Execution` or `Sub Test Execution` **and** the custom field `Test Plan` with the key `com.xpandit.plugins.xray:test-plan-custom-field` is **missing**.

The campaign is created with the following structure:
- id: Pivot id generated
- name: `summary`
- reference: `key`
- status: `status`
- parentType: library node
- description: combination of `description`, `link`, `status`, and `priority`
- scheduled start date: The custom field `Begin Date` with the key `com.atlassian.jira.plugin.system.customfieldtypes:datetime`
- scheduled end date: The custom field `End Date` with the key `com.atlassian.jira.plugin.system.customfieldtypes:datetime`

The date format is `EEE, dd MMM yyyy HH:mm:ss Z` with the `Locale.ENGLISH` locale.
> If the date does not match the format, a warning is logged.
> If the `begin date` or `end date` is not found, a warning is logged.

The campaign is also associated with the test cases.
This association is made using the custom field `Tests associated with a Test Plan` with the key `com.xpandit.plugins.xray:tests-associated-with-test-plan-custom-field`.
For each value in the custom field, the pivot id of the associated test is stored in the JSON array `test_plan_test_case_ids`.
> If an associated test is not found, a warning is logged.

### Iteration
An iteration is created for each issue type `Test Execution` or `Sub Test Execution`.

The iteration is created with the same structure as the campaign with the following differences:
- parent id: Pivot id of the campaign

The parent id is retrieved from the custom field `Test Plan` with the key `com.xpandit.plugins.xray:test-plan-custom-field`.
- If the custom field is not found, the parent id is the same as the issue.
- If the custom field is found:
    - with a single value: the parent id is the pivot id of the test plan
    - with multiple values: the parent id is the pivot id of the first test plan
> If the custom field has multiple values, a warning is logged.
> If the test plan is not found within the import, an error is logged.

The campaign is also associated with the test cases.
This association is made using the custom field `Tests association with a Test Execution` with the key `com.xpandit.plugins.xray:testexec-tests-custom-field`.
